import objectdraw.*;
import java.awt.*;
import java.util.Random;

/*
 * Example VanishingScribble: draw using lines that either fall off the canvas
 * or fade away.
 *
 * Jim Teresco, Siena College, CSIS 120, Spring 2011
 * The College of Saint Rose, Fall 2013
 *
 * $Id: VanishingScribble.java 2218 2013-10-18 14:06:39Z terescoj $
 */

public class VanishingScribble extends WindowController {

    // random generator to pick line types
    private Random whichType = new Random();
    
    // the current line type: 0=fading, 1=falling, 2=rising
    private int lineType;

    // location of last mouse position to draw scribble components
    private Location lastMouse;

    // pick a type of line (fading or falling) for this scribble
    // and remember starting point
    public void onMousePress(Location point) {

        lineType = whichType.nextInt(3);
        lastMouse = point;
    }

    // draw a segment of the appropriate type of line then update lastMouse
    public void onMouseDrag(Location point) {

        if (lineType == 0) {
            new FadingLine(lastMouse, point, canvas);
        }
        else if (lineType == 1) {
            new FallingLine(lastMouse, point, canvas);
        }
        else {
            new RisingLine(lastMouse, point, canvas);
        }
        lastMouse = point;
    }
}
